/*
 * 
 * wftp
 *
 * This plugin was written by Renaud Deraison and is released
 * under the GPL
 *
 */
#include <includes.h>
#define NAME "WFTP (Windows FTP server) login check"
#define DESC "This plugin determines whether the remote ftp daemon \
accepts connections with any username/password, (ie : an old version \
of WFTP)"
#define COPYRIGHT "no copyright"
#define SUMM "checks if WFTP accepts bogus logins"





PlugExport int plugin_init(struct arglist *desc);
PlugExport int plugin_init(struct arglist *desc)
{
	plug_set_name(desc, NAME);
	plug_set_description(desc, DESC);
	plug_set_summary(desc, SUMM);
	plug_set_copyright(desc, COPYRIGHT);
	plug_set_category(desc, ACT_GATHER_INFO);
	plug_set_family(desc, "FTP");
	return(0);
}
	

PlugExport int plugin_run(struct arglist * args);	
PlugExport int plugin_run(struct arglist * args)
{
	int soc;
	char * buf;
	
	
	if(host_get_port_state(args, 21)<=0)return(0);
	soc = open_sock_tcp(args, 21);
	if(soc<0)return(-1);
	buf = emalloc(4096);
	
	recv(soc, buf, 4,0);
        recv(soc, buf+4, 4095,0);    
        
	sprintf(buf, "USER bogussubog\n");
	send(soc, buf, strlen(buf),0);
	bzero(buf,4095);
	recv(soc, buf, 4,0);
	recv(soc, buf+4, 4092,0);
	
	sprintf(buf, "PASS bogussubog\n");
	send(soc, buf, strlen(buf),0);
	bzero(buf,4095);
	recv(soc, buf, 4,0);
	
	if(strstr(buf, "230"))
	{
	 post_hole(args, 21, 
"The remote ftp server accepts connections with\n\
bogus username/password\n\
Solution : upgrade the remote ftp server");	
       }
        efree(&buf);
        socket_close(soc);
	return(0);
}

